/* $Id: smtp.h,v 1.25 2003/10/04 07:24:52 chrisf Exp $ */

/*
GNU Got Mail - An SMTP/POP3 client for the PalmPilot
Copyright (C) 1999 Chris Faherty

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __SMTP_H__
#define __SMTP_H__

enum smtpactions {
    smtpactMATCH,
    smtpactISWHITE,
    smtpactWAITFOR,
	smtpactGETNUM,
	smtpactSENDBODY
};

enum smtpstates {
    smtpstOPEN, smtpstOPEN2, smtpstOPEN3, smtpstOPEN4,
    smtpstHELO, smtpstHELO2, smtpstHELO3, smtpstHELO4,
    smtpstAUTH, smtpstAUTH02, smtpstAUTH03,
    smtpstUSERMD5, smtpstUSER, smtpstUSER02,
    smtpstPASSWD, smtpstPASSWD02,
    smtpstMAIL, smtpstMAIL2,
    smtpstRCPT, smtpstRCPT2,
    smtpstHEAD, smtpstHEAD2, smtpstHEAD3,
    smtpstBODY, smtpstBODY2, smtpstBODY3, smtpstBODY4, smtpstBODY5,
    smtpstCLEARBITS,
    smtpstQUIT, smtpstQUIT2,
    smtpstERROR, smtpstERROR2,
    smtpstALLDONE
};

struct ssmtpdata {
    Int16 error;
	Int32 msgnum;
    Int32 msgstotal;
	Int32 msgrecsize;
    Int32 rcptcount;
	MemHandle msgrechandle;
    char *msgrecptr;
	UInt16 msgrecindex;
	char *patt, *pattb;
	char numbuf[11];
	Int16 numbufcnt;
	Int16 parseAction, parseState, keepdata;
    char *rcptptr;
    Int32 rcptmax;
    Int16 rcptoff, rcptlen, rcptskip, rcpthdr;
    Int16 hdrsubjectoff, hdrsubjectlen;
    Int16 hdrtooff, hdrtolen;
    Int16 hdrccoff, hdrcclen;
    Int16 hdrbccoff, hdrbcclen;
	Int32 msgoff, msglen, msgcnt;
    struct ssq sq;
    char genbuf[65];
    Int16 genbufcnt;
    MemHandle sighandle;
    char *sigptr;
    UInt16 siglen;
    Int16 issignature;
    Int16 outstage;
    UInt32 outoff;
    Int16 inquote;
    Int16 wrotenl;
    UInt16 fileindex, numfiles;
    LocalID dbID;
    MailFlagsType mf;
};

Int32 smtptick(const char *new, Int16 count, Int16 clsock);
Boolean buildrfc822(void);
Boolean getnextrcpt(void);
Boolean filerecord(DateTimeType *sentdate);
Boolean lockrecord(void);
void unlockrecord(void);
Boolean queryrecord(void);
Boolean locksignature(void);
void unlocksignature(void);

#endif
